- today = @calendar[:today]
- date = @calendar[:date].at_beginning_of_month
.tab-info
  .container-z
    .user-leave-board
      - if !@calendar[:users].present?
        .no-request-on-calendar= t('views.stores.dashboard.no_request')
        .div-month-navigation
          = link_to('<', company_dashboard_path(date: date.last_month), class: 'month-navigation') if (date.month > today.month && date.year == today.year) || date.year > today.year
          = link_to t('views.stores.dashboard.today'), company_dashboard_path, class: 'month-navigation link-today'
          = link_to '>', company_dashboard_path(date: date.next_month), class: 'month-navigation'
      - else
        .filter_stuffs
          %form.filter_name_table
            <input type="text" class="filter_name_table" id="name_input" placeholder="User Name" onkeyup="filterName()">
          %form.check_box
            <div><input id="Leave" type="checkbox" onclick="toggleCheckBoxLeave();" name="Leave" value="Leave" checked>Leave</div>
            <div><input id="WFH" type="checkbox" onclick="toggleCheckBoxWFH();" name="WFH" value="WFH" checked />WFH</div>
            <div><input id="Approved" type="checkbox" onclick="toggleCheckBoxApproved();" name="Approved" value="Approved" checked>Approved</div>
            <div><input id="Pending" type="checkbox" onclick="toggleCheckBoxPending();" name="Pending" value="Pending" checked />Pending</div>
          .div-month-navigation
            = link_to('<', company_dashboard_path(date: date.last_month), class: 'month-navigation') if (date.month > today.month && date.year == today.year) || date.year > today.year
            = link_to t('views.stores.dashboard.today'), company_dashboard_path, class: 'month-navigation link-today'
            = link_to '>', company_dashboard_path(date: date.next_month), class: 'month-navigation'

        %table#info_table.table.table-striped.main-board.dash-board-calendar
          %tr
            %td.td-solid-boder.td-calendar.td-current-month
              = "#{date.strftime('%B %Y')}"
            = display_days_of_calendar(date, today)
          - @calendar[:users].each do |user|
            %tr
              %td.td-solid-boder.td-user-name
                %span{'data-toggle'=> 'tooltip', 'data-placement' => 'top', 'title' => "#{user[:user_info].full_name}"}
                  = display_user_with_avatar(user[:user_info])
              = display_user_request_range(date, user[:request_duration], today)
          .legend-calendar
          %table#legend_table
            %tr
              %td.td-calendar-cell-width{bgcolor: "#{APPROVED_LEAVE_COLOR}"}
              %td.td-legend-text= t('views.stores.dashboard.approved_leave')
              %td.td-calendar-cell-width{bgcolor: "#{APPROVED_WFH_COLOR}"}
              %td.td-legend-text= t('views.stores.dashboard.approved_wfh')
              %td.td-calendar-cell-width{bgcolor: "#{PENDING_LEAVE_COLOR}"}
              %td.td-legend-text= t('views.stores.dashboard.pending_leave')
              %td.td-calendar-cell-width{bgcolor: "#{PENDING_WFH_COLOR}"}
              %td.td-legend-text= t('views.stores.dashboard.pending_wfh')

:javascript
  function englishize(str) {
  str = str.replace(/à|á|ạ|ả|ã|â|ầ|ấ|ậ|ẩ|ẫ|ă|ằ|ắ|ặ|ẳ|ẵ/g, "a");
  str = str.replace(/è|é|ẹ|ẻ|ẽ|ê|ề|ế|ệ|ể|ễ/g, "e");
  str = str.replace(/ì|í|ị|ỉ|ĩ/g, "i");
  str = str.replace(/ò|ó|ọ|ỏ|õ|ô|ồ|ố|ộ|ổ|ỗ|ơ|ờ|ớ|ợ|ở|ỡ/g, "o");
  str = str.replace(/ù|ú|ụ|ủ|ũ|ư|ừ|ứ|ự|ử|ữ/g, "u");
  str = str.replace(/ỳ|ý|ỵ|ỷ|ỹ/g, "y");
  str = str.replace(/đ/g, "d");
  str = str.replace(/À|Á|Ạ|Ả|Ã|Â|Ầ|Ấ|Ậ|Ẩ|Ẫ|Ă|Ằ|Ắ|Ặ|Ẳ|Ẵ/g, "A");
  str = str.replace(/È|É|Ẹ|Ẻ|Ẽ|Ê|Ề|Ế|Ệ|Ể|Ễ/g, "E");
  str = str.replace(/Ì|Í|Ị|Ỉ|Ĩ/g, "I");
  str = str.replace(/Ò|Ó|Ọ|Ỏ|Õ|Ô|Ồ|Ố|Ộ|Ổ|Ỗ|Ơ|Ờ|Ớ|Ợ|Ở|Ỡ/g, "O");
  str = str.replace(/Ù|Ú|Ụ|Ủ|Ũ|Ư|Ừ|Ứ|Ự|Ử|Ữ/g, "U");
  str = str.replace(/Ỳ|Ý|Ỵ|Ỷ|Ỹ/g, "Y");
  str = str.replace(/Đ/g, "D");
  return str;
  }
  function filterName(){
  let textInput = document.getElementById('name_input').value.toUpperCase();
  let table = document.getElementById("info_table");
  for(let i=1; i<table.rows.length; i++){
      let compareString = table.rows[i].cells[0].innerText.toUpperCase();
      compareString = englishize(compareString);
      if(compareString.indexOf(textInput)>-1){
          let count = 0;
          for(let j=1; j<table.rows[i].cells.length; j++){
              let child = table.rows[i].cells[j].getElementsByTagName('div');
              let len = child.length;
              if(len>0){
                  for(let k=0; k<len; k++)
                      if(child[k].innerText == "On") count++;
              }
          }
          if(count > 0) table.rows[i].style.display="";
      }
      else{
          let count = 0;
          for(let j=1; j<table.rows[i].cells.length; j++){
              let child = table.rows[i].cells[j].getElementsByTagName('div');
              let len = child.length;
              if(len>0){
                  for(let k=0; k<len; k++)
                      if(child[k].innerText == "On") count++;
              }
          }
          if(count > 0) table.rows[i].style.display="none";
      }
  }
  }
  /*
  Initialize the value of table cells, not including the first row and the first column.
  Approved Leave (Green): 1;
  Approved WFH (Orange): 2;
  Pending Leave (Blue): 3;
  Pending WFH (Purple): 4;
  */
  window.onload = function(){
  let table = document.getElementById("info_table");
  if(table != null){
    for(let i=1; i<table.rows.length; i++){
        for(let j=1; j<table.rows[i].cells.length; j++){
            let child = table.rows[i].cells[j].getElementsByTagName('div');
            let len = child.length;
            if(len>0){
                for(let k=0; k<len; k++){
                    if(child[k].style.backgroundColor == "rgb(86, 166, 86)"){
                        child[k].value=1;
                        child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                    }
                    else if(child[k].style.backgroundColor == "rgb(236, 151, 31)"){
                        child[k].value=2;
                        child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                    }
                    else if(child[k].style.backgroundColor == "rgb(77, 139, 192)"){
                        child[k].value=3;
                        child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                    }
                    else if(child[k].style.backgroundColor == "rgb(170, 0, 255)"){
                        child[k].value=4;
                        child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                    }
                    else {
                        child[k].value=0;
                        child[k].innerHTML="<span style='font-size: 0px'>Off</span>";
                    }
                }
            }
            else {
                child.value=0;
                child.innerHTML="<span style='font-size: 0px'>Off</span>";
            }
        }
    }
  }
  }
  function isAnyLeaveWFHChecked(){
  let leave=document.getElementById("Leave").checked;
  let wfh=document.getElementById("WFH").checked;
  if(leave==false && wfh==false) return false;
  else return true;
  }
  function isAnyApprovedPendingChecked(){
  let approved=document.getElementById("Approved").checked;
  let pending=document.getElementById("Pending").checked;
  if(approved==false && pending==false) return false;
  else return true;
  }
  //hide the cell has the value equal to the input variable, make its color transparent and write an invisible 'Off' on it.
  function hideCell(value){
  let table = document.getElementById("info_table");
  for(let i=1; i<table.rows.length; i++){
      for(let j=1; j<table.rows[i].cells.length; j++){
          let child = table.rows[i].cells[j].getElementsByTagName('div');
          let len = child.length;
          if(len>0)
              for(let k=0; k<len; k++)
                  if(child[k].value == value){
                      child[k].style.backgroundColor="transparent";
                      child[k].innerHTML="<span style='font-size: 0px'>Off</span>";
                  }
      }
  }
  }
  //display the cell has the value equal to the input variable, set its backgroundColor based on its value and write an invisible 'On' on it.
  function displayCell(value){
  let table = document.getElementById("info_table");
  for(let i=1; i<table.rows.length; i++){
      for(let j=1; j<table.rows[i].cells.length; j++){
          let child = table.rows[i].cells[j].getElementsByTagName('div');
          let len = child.length;
          if(len>0){
              for(let k=0; k<len; k++){
                  switch(value){
                      case 1:
                          if(child[k].value==1){
                              child[k].style.backgroundColor = "rgb(86, 166, 86)";
                              child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                          }
                          break;
                      case 2:
                          if(child[k].value==2){
                              child[k].style.backgroundColor = "rgb(236, 151, 31)";
                              child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                          }
                          break;
                      case 3:
                          if(child[k].value==3){
                              child[k].style.backgroundColor = "rgb(77, 139, 192)";
                              child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                          }
                          break;
                      case 4:
                          if(child[k].value==4){
                              child[k].style.backgroundColor = "rgb(170, 0, 255)";
                              child[k].innerHTML="<span style='font-size: 0px'>On</span>";
                          }
                          break;
                  }
              }
          }
      }
  }
  }
  //Hide the rows that have no visible request ticket
  function hideRow(value1, value2){
  let table = document.getElementById("info_table");
  for(let i=1; i<table.rows.length; i++){
      let count = 0;
      for(let j=1; j<table.rows[i].cells.length; j++){
          let child = table.rows[i].cells[j].getElementsByTagName('div');
          let len = child.length;
          if(len>0){
              for(let k=0; k<len; k++)
                  if(child[k].value >0 && child[k].value != value1 && child[k].value != value2)
                  //count++ when the rows have types of request different from the two input ones.
                      if(child[k].innerText == "On") count++;
          }
      }
      //when the rows have no type of request different from the two input ones, hide them.
      if(count == 0) table.rows[i].style.display="none";
  }
  }
  function displayRow(value1, value2){
  let table = document.getElementById("info_table");
  let textInput = document.getElementById('name_input').value.toUpperCase();
  for(let i=1; i<table.rows.length; i++){
      let count = 0;
      for(let j=1; j<table.rows[i].cells.length; j++){
          let child = table.rows[i].cells[j].getElementsByTagName('div');
          let len = child.length;
          if(len>0){
              for(let k=0; k<len; k++)
                  if(child[k].value == value1 || child[k].value == value2)
                      if(child[k].innerText=="On") count++;
          }
      }
      if(count > 0 && englishize(table.rows[i].cells[0].innerText.toUpperCase()).indexOf(textInput)>-1) table.rows[i].style.display='';
  }
  }
  function toggleCheckBoxLeave(){
  let table = document.getElementById("info_table");
  let leave=document.getElementById("Leave").checked;
  let wfh=document.getElementById("WFH").checked;
  let approved=document.getElementById("Approved").checked;
  let pending=document.getElementById("Pending").checked;
  let textInput = document.getElementById('name_input').value.toUpperCase();
  if(!isAnyLeaveWFHChecked()){
      alert("You must choose at least one kind of request!");
      document.getElementById("Leave").checked = "checked";
      leave = true;
  }
  else if(leave == false && isAnyLeaveWFHChecked()){
      if(approved == true) hideCell(1);
      if(pending == true) hideCell(3);
      hideRow(1,3);
  }
  else if(leave == true){
      if(approved == true) displayCell(1);
      if(pending == true) displayCell(3);
      displayRow(1,3);
  }
  }
  function toggleCheckBoxWFH(){
  let table = document.getElementById("info_table");
  let leave=document.getElementById("Leave").checked;
  let wfh=document.getElementById("WFH").checked;
  let approved=document.getElementById("Approved").checked;
  let pending=document.getElementById("Pending").checked;
  let textInput = document.getElementById('name_input').value.toUpperCase();
  if(!isAnyLeaveWFHChecked()){
      alert("You must choose at least one kind of request!");
      document.getElementById("WFH").checked = "checked";
      wfh = true;
  }
  else if(wfh == false && isAnyLeaveWFHChecked()){
      if(approved == true) hideCell(2);
      if(pending == true) hideCell(4);
      hideRow(2,4);
  }
  else if(wfh == true){
      if(approved == true) displayCell(2);
      if(pending == true) displayCell(4);
      displayRow(2,4);
  }
  }
  function toggleCheckBoxApproved(){
  let table = document.getElementById("info_table");
  let leave=document.getElementById("Leave").checked;
  let wfh=document.getElementById("WFH").checked;
  let approved=document.getElementById("Approved").checked;
  let pending=document.getElementById("Pending").checked;
  let textInput = document.getElementById('name_input').value.toUpperCase();
  if(!isAnyApprovedPendingChecked()){
      alert("You must choose at least one kind of status!");
      document.getElementById("Approved").checked = "checked";
      approved = true;
  }
  else if(approved == false && isAnyApprovedPendingChecked()){
      if(leave == true) hideCell(1);
      if(wfh == true) hideCell(2);
      hideRow(1,2);
  }
  else if(approved == true){
      if(leave == true) displayCell(1);
      if(wfh == true) displayCell(2);
      displayRow(1,2);
  }
  }
  function toggleCheckBoxPending(){
  let table = document.getElementById("info_table");
  let leave=document.getElementById("Leave").checked;
  let wfh=document.getElementById("WFH").checked;
  let approved=document.getElementById("Approved").checked;
  let pending=document.getElementById("Pending").checked;
  let textInput = document.getElementById('name_input').value.toUpperCase();
  if(!isAnyApprovedPendingChecked()){
      alert("You must choose at least one kind of status!");
      document.getElementById("Pending").checked = "checked";
      pending = true;
  }
  else if(pending == false && isAnyApprovedPendingChecked()){
      if(leave == true) hideCell(3);
      if(wfh == true) hideCell(4);
      hideRow(3,4);
  }
  else if(pending == true){
      if(leave == true) displayCell(3);
      if(wfh == true) displayCell(4);
      displayRow(3,4);
  }
  }
